Python在线运行

版本:
运行结果
教程手册
代码仓库
极速运行
交互输入
极速运行模式,更高效的运行,点击编辑器上方的运行按钮即刻体验吧。
以下是用户最新保存的代码
学习python的点点滴滴 发布于:2022-01-28 21:49 小星星python 发布于:2022-01-17 21:12 多行字符串和级联字符串 发布于:2022-01-10 11:21 判断字符串 发布于:2022-01-10 10:25 字符串截取 发布于:2022-01-10 09:24 亨利猜单词 发布于:2022-01-09 22:21 杭州八校联考2021期中信息技术15题 发布于:2022-01-06 13:44 6.转义字符和原字符 发布于:2021-12-30 23:39 5.将数据输出到文件中 发布于:2021-12-30 23:39 简单的笔记 发布于:2021-12-29 15:32 转义字符的使用 发布于:2021-12-29 12:52 音乐爬取python 发布于:2021-12-23 18:06 EDG牛逼! 发布于:2021-12-17 22:03 Data Frame类对象 Index索引 loc既包含起始索引又包含结束索引 i loc只包含起始索引 发布于:2021-12-14 17:37 DateFrame二维数组 index索引 发布于:2021-12-14 17:49 学习通爬虫 发布于:2021-12-13 22:47 矩阵创建 1.矩阵函数 np.mat和np.matrix等价 2.np.array使用二维数组代替矩阵,常见的操作通用 3.shape属性获取矩阵大小 4.单位阵的创建I=np.eye() 5.获取矩阵的某一行a[ ] 6.获取矩阵的某一列line13 7.获取矩阵某个元素 发布于:2021-12-07 20:28 输出1到100之间所有的质数 发布于:2021-12-07 17:37 用列表编程,输入一个包含若干整数的列表,输出由其中的偶数组成的新列表 发布于:2021-12-07 17:33 用列表编程,输入两个包含若干整数的等长列表表示的两个向量,输出这两个向量的内积,并分别输出两个向量的最大值最小值的下标组成的列表 发布于:2021-12-07 17:44 编写程序,从键盘输入矩形的长和宽,并输出矩形面积 发布于:2021-12-07 17:15 数组创建/初始化numpy.linspace(start, stop[, num=50[, endpoint=True[, retstep=False[, dtype=None]]]]]) num - 元素个数,默认为50 endpoint - 是否包含stop数值,默认为True,包含stop值;若为False,则不包含stop值 retstep - 返回值形式,默认为False,返回等差数列组,若为True,则返回结果(array([samples, step])), return 在指定范围内的均匀间隔的数字(组成的数组),也即返回一个等差数列 发布于:2021-12-07 18:57 随机生成一个二维数组np.random.rand() 发布于:2021-12-07 16:51 矩阵乘法dot() 计算对角线元素和trace() 计算矩阵行列式det() 一维数组形式放回方针对角线diag() 计算方针的逆inv() 发布于:2021-12-07 16:44 hill解密 发布于:2021-12-02 08:38 RSA加密 发布于:2021-11-30 19:56 转换格式+输出最大.imag最小值.real+ 发布于:2021-12-07 16:14 numpy数组 15:随机数数组 22:等差数组【range()返回的是列表】 发布于:2021-12-14 17:40 序列密码完 发布于:2021-11-26 19:57 针对某个判定条件,一次成功就不回溯 发布于:2021-11-24 12:38 爱心函数zm 发布于:2021-11-23 17:38 des加密 发布于:2021-11-23 16:31 hill密码 发布于:2021-11-23 14:11 维吉尼亚密码破解 发布于:2021-12-27 14:00 维吉尼亚密码加密解密 发布于:2021-12-27 11:18 学生类实现一些方法 发布于:2021-11-15 09:53 修改字符串中的字母 发布于:2021-11-15 09:25 去除html标记 发布于:2021-11-15 09:21 输出长度为3的单词 发布于:2021-11-15 09:17 去除多余单词 发布于:2021-11-15 09:13 利用函数模拟报数游戏 发布于:2021-11-15 09:00 查找给定序列的最长递增子序列 发布于:2021-11-15 08:52 打印一个列表中数字的平方和 发布于:2021-11-15 08:49 判断密码强度 发布于:2021-11-15 08:39 22题 2021-11-12 解决数学问题 发布于:2021-11-12 21:14 一键批量生成随机数(Python) 发布于:2021-11-07 16:35 数据提取-1  请你通过所学知识,把列表list1中的'love'取出来,并打印出来。  数据提取-2  请你通过所学知识,把字典dict1中的'love'取出来,并打印出来。  拓展知识:元组  下面,介绍一种新的数据类型:元组(tuple)。 可以看到:元组和表格很相似,不过,它是用小括号来包的。 元组和列表都是序列,提取的方式也是偏移量,如 tuple1[1]、tuple1[1:]。另外,元组也支持任意的嵌套。 请你根据以上提供的信息,将tuple1中的A和list2中的D打印出来。看到了,理解了,运用了,就能够掌握了。 发布于:2021-11-06 20:47 如何取出字典里的值了。删除字典里键值对的代码是del语句del 字典名[键],而新增键值对要用到赋值语句字典名[键] = 值。两者数据读取方法会不同的原因:列表有序,要用偏移量定位;字典无序,便通过唯一的键来取值。 发布于:2021-11-06 20:05 列表提取,增加删除元素 发布于:2021-11-06 15:38 append后的括号里只能接受一个参数,但却给了两个,也就是4和5。所以,用append()给列表增加元素,每次只能增加一个元素。 发布于:2021-11-06 15:23 [更多]
显示目录

异常处理



Python 异常处理

python提供了两个非常重要的功能来处理python程序在运行中出现的异常和错误。你可以使用该功能来调试python程序。

  • 异常处理: 本站Python教程会具体介绍。
  • 断言(Assertions):本站Python教程会具体介绍。

python标准异常

异常名称 描述
BaseException 所有异常的基类
SystemExit 解释器请求退出
KeyboardInterrupt 用户中断执行(通常是输入^C)
Exception 常规错误的基类
StopIteration 迭代器没有更多的值
GeneratorExit 生成器(generator)发生异常来通知退出
StandardError 所有的内建标准异常的基类
ArithmeticError 所有数值计算错误的基类
FloatingPointError 浮点计算错误
OverflowError 数值运算超出最大限制
ZeroDivisionError 除(或取模)零 (所有数据类型)
AssertionError 断言语句失败
AttributeError 对象没有这个属性
EOFError 没有内建输入,到达EOF 标记
EnvironmentError 操作系统错误的基类
IOError 输入/输出操作失败
OSError 操作系统错误
WindowsError 系统调用失败
ImportError 导入模块/对象失败
LookupError 无效数据查询的基类
IndexError 序列中没有此索引(index)
KeyError 映射中没有这个键
MemoryError 内存溢出错误(对于Python 解释器不是致命的)
NameError 未声明/初始化对象 (没有属性)
UnboundLocalError 访问未初始化的本地变量
ReferenceError 弱引用(Weak reference)试图访问已经垃圾回收了的对象
RuntimeError 一般的运行时错误
NotImplementedError 尚未实现的方法
SyntaxError Python 语法错误
IndentationError 缩进错误
TabError Tab 和空格混用
SystemError 一般的解释器系统错误
TypeError 对类型无效的操作
ValueError 传入无效的参数
UnicodeError Unicode 相关的错误
UnicodeDecodeError Unicode 解码时的错误
UnicodeEncodeError Unicode 编码时错误
UnicodeTranslateError Unicode 转换时错误
Warning 警告的基类
DeprecationWarning 关于被弃用的特征的警告
FutureWarning 关于构造将来语义会有改变的警告
OverflowWarning 旧的关于自动提升为长整型(long)的警告
PendingDeprecationWarning 关于特性将会被废弃的警告
RuntimeWarning 可疑的运行时行为(runtime behavior)的警告
SyntaxWarning 可疑的语法的警告
UserWarning 用户代码生成的警告

什么是异常?

异常即是一个事件,该事件会在程序执行过程中发生,影响了程序的正常执行。

一般情况下,在Python无法正常处理程序时就会发生一个异常。

异常是Python对象,表示一个错误。

当Python脚本发生异常时我们需要捕获处理它,否则程序会终止执行。


异常处理

捕捉异常可以使用try/except语句。

try/except语句用来检测try语句块中的错误,从而让except语句捕获异常信息并处理。

如果你不想在异常发生时结束你的程序,只需在try里捕获它。

语法:

以下为简单的try....except...else的语法:

try:
<语句>        #运行别的代码
except <名字>:
<语句>        #如果在try部份引发了'名字'异常
except <名字>,<数据>:
<语句>        #如果引发了'名字'异常,获得附加的数据
else:
<语句>        #如果没有异常发生

try的工作原理是,当开始一个try语句后,python就在当前程序的上下文中作标记,这样当异常出现时就可以回到这里,try子句先执行,接下来会发生什么依赖于执行时是否出现异常。

  • 如果当try后的语句执行时发生异常,python就跳回到try并执行第一个匹配该异常的except子句,异常处理完毕,控制流就通过整个try语句(除非在处理异常时又引发新的异常)。
  • 如果在try后的语句里发生了异常,却没有匹配的except子句,异常将被递交到上层的try,或者到程序的最上层(这样将结束程序,并打印缺省的出错信息)。
  • 如果在try子句执行时没有发生异常,python将执行else语句后的语句(如果有else的话),然后控制流通过整个try语句。

实例

下面是简单的例子,它打开一个文件,在该文件中的内容写入内容,且并未发生异常:

#!/usr/bin/python

try:
   fh = open("testfile", "w")
   fh.write("This is my test file for exception handling!!")
except IOError:
   print "Error: can\'t find file or read data"
else:
   print "Written content in the file successfully"
   fh.close()

以上程序输出结果:

 Written content in the file successfully

实例

下面是简单的例子,它打开一个文件,在该文件中的内容写入内容,但文件没有写入权限,发生了异常:

#!/usr/bin/python

try:
   fh = open("testfile", "w")
   fh.write("This is my test file for exception handling!!")
except IOError:
   print "Error: can\'t find file or read data"
else:
   print "Written content in the file successfully"

以上程序输出结果:

Error: can't find file or read data

使用except而不带任何异常类型

你可以不带任何异常类型使用except,如下实例:

try:
   You do your operations here;
   ......................
except:
   If there is any exception, then execute this block.
   ......................
else:
   If there is no exception then execute this block.

以上方式try-except语句捕获所有发生的异常。但这不是一个很好的方式,我们不能通过该程序识别出具体的异常信息。因为它捕获所有的异常。



使用except而带多种异常类型

你也可以使用相同的except语句来处理多个异常信息,如下所示:

try:
   You do your operations here;
   ......................
except(Exception1[, Exception2[,...ExceptionN]]]):
   If there is any exception from the given exception list, 
   then execute this block.
   ......................
else:
   If there is no exception then execute this block.

try-finally 语句

try-finally 语句无论是否发生异常都将执行最后的代码。

try:
<语句>
finally:
<语句>    #退出try时总会执行
raise

注意:你可以使用except语句或者finally语句,但是两者不能同时使用。else语句也不能与finally语句同时使用

实例

#!/usr/bin/python

try:
   fh = open("testfile", "w")
   fh.write("This is my test file for exception handling!!")
finally:
   print "Error: can\'t find file or read data"

如果打开的文件没有可写权限,输出如下所示:

Error: can't find file or read data

同样的例子也可以写成如下方式:

#!/usr/bin/python

try:
   fh = open("testfile", "w")
   try:
      fh.write("This is my test file for exception handling!!")
   finally:
      print "Going to close the file"
      fh.close()
except IOError:
   print "Error: can\'t find file or read data"

当在try块中抛出一个异常,立即执行finally块代码。

finally块中的所有语句执行后,异常被再次提出,并执行except块代码。

参数的内容不同于异常。


异常的参数

一个异常可以带上参数,可作为输出的异常信息参数。

你可以通过except语句来捕获异常的参数,如下所示:

try:
   You do your operations here;
   ......................
except ExceptionType, Argument:
   You can print value of Argument here...

变量接收的异常值通常包含在异常的语句中。在元组的表单中变量可以接收一个或者多个值。

元组通常包含错误字符串,错误数字,错误位置。

实例

以下为单个异常的实例:

#!/usr/bin/python

# 定义函数
def temp_convert(var):
   try:
      return int(var)
   except ValueError, Argument:
      print "The argument does not contain numbers\n", Argument

# 调用函数
temp_convert("xyz");

以上程序执行结果如下:

The argument does not contain numbers
invalid literal for int() with base 10: 'xyz'

触发异常

我们可以使用raise语句自己触发异常

raise语法格式如下:

raise [Exception [, args [, traceback]]]

语句中Exception是异常的类型(例如,NameError)参数是一个异常参数值。该参数是可选的,如果不提供,异常的参数是"None"。

最后一个参数是可选的(在实践中很少使用),如果存在,是跟踪异常对象。

实例

一个异常可以是一个字符串,类或对象。 Python的内核提供的异常,大多数都是实例化的类,这是一个类的实例的参数。

定义一个异常非常简单,如下所示:

def functionName( level ):
    if level < 1:
        raise Exception("Invalid level!", level)
        # 触发异常后,后面的代码就不会再执行

注意:为了能够捕获异常,"except"语句必须有用相同的异常来抛出类对象或者字符串。

例如我们捕获以上异常,"except"语句如下所示:

try:
   Business Logic here...
except "Invalid level!":
   Exception handling here...
else:
   Rest of the code here...

用户自定义异常

通过创建一个新的异常类,程序可以命名它们自己的异常。异常应该是典型的继承自Exception类,通过直接或间接的方式。

以下为与RuntimeError相关的实例,实例中创建了一个类,基类为RuntimeError,用于在异常触发时输出更多的信息。

在try语句块中,用户自定义的异常后执行except块语句,变量 e 是用于创建Networkerror类的实例。

class Networkerror(RuntimeError):
   def __init__(self, arg):
      self.args = arg

在你定义以上类后,你可以触发该异常,如下所示:

try:
   raise Networkerror("Bad hostname")
except Networkerror,e:
   print e.args

异常处理代码执行说明:

#!/usr/bin/python
# -*- coding: UTF-8 -*-

#This is note foe exception

try:
  code    #需要判断是否会抛出异常的代码,如果没有异常处理,python会直接停止执行程序

except:  #这里会捕捉到上面代码中的异常,并根据异常抛出异常处理信息
#except ExceptionName,args:    #同时也可以接受异常名称和参数,针对不同形式的异常做处理

  code  #这里执行异常处理的相关代码,打印输出等

else:  #如果没有异常则执行else

  code  #try部分被正常执行后执行的代码

finally:
  code  #退出try语句块总会执行的程序

#函数中做异常检测
def try_exception(num):
  try:
    return int(num)
  except ValueError,arg:
    print arg,"is not a number"
  else:
    print "this is a number inputs"

try_exception('xxx')

#输出异常值
Invalide literal for int() with base 10: 'xxx' is not a number
由JSRUN为你提供的Python在线运行、在线编译工具
        JSRUN提供的Python在线运行,Python 在线运行工具,基于linux操作系统环境提供线上编译和线上运行,具有运行快速,运行结果与常用开发、生产环境保持一致的特点。

title

使用此草稿 删除草稿

  • 00:23
注册登录后可减少验证码的弹出,点击前往 注册 | 登录

皮肤:

运行模式:

嵌入代码 iframe嵌入:


服务器已安装大部分常用的第依赖库,但仍可能存在一些未被安装的库, 可以通过本窗口立即安装所需依赖库。


请输入依赖库的名称:

请选择语言: